diff -r 11a8f1275a38 sys/netinet/tcp_input.c
--- a/sys/netinet/tcp_input.c	Mon Jul 16 20:17:19 2012 +0000
+++ b/sys/netinet/tcp_input.c	Mon Mar 11 02:59:51 2013 +1100
@@ -56,6 +56,7 @@
 #include "opt_ipsec.h"
 #include "opt_tcpdebug.h"
 
+#include <sys/endian.h>
 #include <sys/param.h>
 #include <sys/kernel.h>
 #include <sys/hhook.h>
@@ -63,12 +64,18 @@
 #include <sys/mbuf.h>
 #include <sys/proc.h>		/* for proc0 declaration */
 #include <sys/protosw.h>
+#include <sys/sbuf.h>
 #include <sys/signalvar.h>
 #include <sys/socket.h>
 #include <sys/socketvar.h>
 #include <sys/sysctl.h>
 #include <sys/syslog.h>
 #include <sys/systm.h>
+#include <sys/kdb.h>
+
+#include <sys/lock.h>
+#include <sys/mutex.h>
+#include <sys/limits.h>
 
 #include <machine/cpu.h>	/* before tcp_seq.h, for tcp_random18() */
 
@@ -109,6 +116,12 @@
 #include <netinet/tcp_offload.h>
 #endif
 
+#include <netinet/mptcp.h>
+#include <netinet/mptcp_var.h>
+#include <netinet/sctp_pcb.h>
+#include <netinet/sctp_auth.h>
+#include <netinet/sctp_constants.h>
+
 #ifdef IPSEC
 #include <netipsec/ipsec.h>
 #include <netipsec/ipsec6.h>
@@ -136,7 +149,7 @@
     &VNET_NAME(blackhole), 0,
     "Do not send RST on segments to closed ports");
 
-VNET_DEFINE(int, tcp_delack_enabled) = 1;
+VNET_DEFINE(int, tcp_delack_enabled) = 0;
 SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, delayed_ack, CTLFLAG_RW,
     &VNET_NAME(tcp_delack_enabled), 0,
     "Delay ACK to try and piggyback it onto a data packet");
@@ -209,6 +222,14 @@
     &VNET_NAME(tcp_autorcvbuf_max), 0,
     "Max size of automatic receive buffer");
 
+VNET_DEFINE(int, tcp_do_mptcp) = 1;
+#define	V_tcp_do_mptcp	VNET(tcp_do_mptcp)
+SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, mptcp, CTLFLAG_RW,
+    &VNET_NAME(tcp_do_mptcp), 0,
+    "Enable Multipath Support");
+
+MALLOC_DEFINE(M_DSSMAP, "dssmap", "Struct to hold dss maps");
+
 VNET_DEFINE(struct inpcbhead, tcb);
 #define	tcb6	tcb  /* for KAME src sync over BSD*'s */
 VNET_DEFINE(struct inpcbinfo, tcbinfo);
@@ -237,6 +258,16 @@
 			    struct tcphdr *th, struct tcpopt *to);
 
 /*
+ * MPTCP functions for handling new MPTCP-generated TCP options and
+ * mptcp connection states
+ */
+static void inline mp_dosubtypes(struct tcpopt *to, uint8_t subtype,
+		u_char *cp, int opt, int optlen, int flags);
+static uint64_t inline mp_get_ds_64_upper(struct mpcb *mp);
+
+#define MSBIT_CHECK 0x80000000
+
+/*
  * Kernel module interface for updating tcpstat.  The argument is an index
  * into tcpstat treated as an array of u_long.  While this encodes the
  * general layout of tcpstat into the caller, it doesn't encode its location,
@@ -250,6 +281,288 @@
 	(*((u_long *)&V_tcpstat + statnum))++;
 }
 
+
+static inline uint64_t
+mp_get_ds_64_upper(struct mpcb *mp) {
+	return (mp->ds_map_max & 0xFFFFFFFF00000000);
+}
+
+static void inline
+mp_dosubtypes(struct tcpopt *to, uint8_t subtype, u_char *cp, int opt, int optlen, int flags) {
+	int byte_offset;
+	struct mp_capable mcap;
+	struct mp_join mjoin;
+
+	subtype = subtype >> 4;
+
+	switch(subtype)
+	{
+	case MPTCP_SUBTYPE_MP_CAPABLE:
+	{
+		// have to check that the 's' bit is set
+		// also should check for the dss csum bit (for now just ignore it...)
+		if (optlen != MPTCP_SUBLEN_MP_CAPABLE_SYN &&
+				optlen != MPTCP_SUBLEN_MP_CAPABLE_ACK) {
+			break;
+		}
+
+		/* indicate we have mptcp options present */
+		to->to_flags |= TOF_MPTCP;
+		to->to_mopts.mpo_flags |= MPOF_MP_CAPABLE;
+
+		if ((flags & TO_SYN) &&
+				(optlen == MPTCP_SUBLEN_MP_CAPABLE_SYN)) {
+
+				bcopy((char *)cp,(char *)&mcap,
+						sizeof(struct mp_capable));
+
+				/* using checksums? */
+				if (mcap.flags & USE_CSUM) {
+					to->to_mopts.mpo_flags |= MPOF_USE_CSUM;
+				}
+
+				/* need to save the incoming key */
+				bcopy((char *)cp + MP_REMOTE_KEY_OFFSET,
+						(char *)&to->to_mopts.remote_key,
+						sizeof(to->to_mopts.remote_key));
+		}
+
+		if (optlen == MPTCP_SUBLEN_MP_CAPABLE_ACK) {
+			/* do some validation here */
+		}
+		break;
+	}
+	case MPTCP_SUBTYPE_DSS:
+	{
+			byte_offset = 0;
+			uint8_t	dss_flags;
+
+			to->to_mopts.mpo_flags |= MPOF_DSS;
+
+			//dss_flags = (uint8_t) cp + MP_DSS_FLAGS_OFFSET;
+			bcopy((char *)cp + MP_DSS_FLAGS_OFFSET,(char *)&dss_flags,
+							sizeof(uint8_t));
+
+			/* Data-FIN present */
+			if(dss_flags & FIN_PRESENT)
+				to->to_mopts.mpo_flags |= MPOF_DATA_FIN;
+
+			/* Data-ACK present */
+			if (dss_flags & ACK_PRESENT) {
+				// set flag that we have an ACK
+				to->to_mopts.mpo_flags |= MPOF_DATA_ACK;
+
+				/* Is 64-bit Data ACK present */
+				if (dss_flags & ACK_64_PRESENT) {
+					to->to_mopts.mpo_flags |= MPOF_ACK64;
+					bcopy((char *)cp + MP_DATA_ACK64_OFFSET,	// grabbing whole 64-bits
+						(char *)&to->to_mopts.data_ack_num,
+						sizeof(to->to_mopts.data_ack_num));
+					to->to_mopts.data_ack_num =
+							be64toh(to->to_mopts.data_ack_num);
+					byte_offset += 8;	// offset the presence of 64-bit ACK
+				} else {
+					uint32_t short_data_ack;
+					bcopy((char *)cp + MP_DATA_ACK_OFFSET,
+						(char *)&short_data_ack,
+						sizeof(short_data_ack));
+					//to->to_mopts.data_ack_num = (uint64_t) ntohl(short_data_ack);
+					to->to_mopts.data_ack_num = ntohl(short_data_ack);
+					byte_offset += 4; // offset the presence of 32-bit ACK
+				}
+			}
+
+			/* DSN, SSN, length and csum present */
+			if (dss_flags & MAP_PRESENT) {
+				/* flag the new DSN Mapping for this subflow */
+				to->to_mopts.mpo_flags |= MPOF_DSN_MAP;
+
+				/* Is DSN 8 octets */
+				if (dss_flags & DSN_64) {
+					bcopy((char *)cp + MP_DSN_OFFSET + byte_offset,
+						(char *)&to->to_mopts.data_seq_num,
+						sizeof(to->to_mopts.data_seq_num));
+					to->to_mopts.data_seq_num = be64toh(to->to_mopts.data_seq_num);
+					byte_offset += 4;
+					to->to_mopts.mpo_flags |= MPOF_DSN64;
+				} else {
+					uint32_t short_dsn;
+					bcopy((char *)cp + MP_DSN_OFFSET + byte_offset,
+						(char *)&short_dsn,
+						sizeof(short_dsn));
+					to->to_mopts.data_seq_num = (uint64_t) ntohl(short_dsn);
+				}
+
+				/* subflow sequence number */
+				bcopy((char *)cp + MP_SUB_SEQN_OFFSET + byte_offset,
+					(char *)&to->to_mopts.sub_seq_num,
+					sizeof(to->to_mopts.sub_seq_num));
+				to->to_mopts.sub_seq_num = ntohl(to->to_mopts.sub_seq_num);
+
+				/* Data-level length */
+				bcopy((char *)cp + MP_DATA_LEN_OFFSET + byte_offset,
+					(char *)&to->to_mopts.dss_data_len,
+					sizeof(to->to_mopts.dss_data_len));
+				to->to_mopts.dss_data_len = ntohs(to->to_mopts.dss_data_len);
+
+				/* checksum */
+				// XXX: need to check if using csums
+				// should do this by checking the length of the option
+				// at the start and keeping track along the way....
+
+//					bcopy((char *)cp + MP_CSUM_OFFSET + byte_offset,
+//						(char *)&to->to_mopts.dss_csum,
+//						sizeof(to->to_mopts.dss_csum));
+//					to->to_mopts.dss_csum = ntohs(to->to_mopts.dss_csum);
+			}
+			break;
+	}
+	case MPTCP_SUBTYPE_MP_JOIN:
+	{
+		/* SYN-only segments are processed in mp_check_for_join */
+		if (optlen != MPTCP_SUBLEN_MP_JOIN_SYN &&
+			optlen != MPTCP_SUBLEN_MP_JOIN_SYNACK &&
+			optlen != MPTCP_SUBLEN_MP_JOIN_ACK) {
+			break;
+		}
+
+		/* can use optlen to differentiate subtype variations */
+		to->to_mopts.optlen = optlen;
+
+		switch (optlen)
+		{
+		case MPTCP_SUBLEN_MP_JOIN_SYN:
+			to->to_flags |= TOF_MPTCP;
+
+			/* copy address id */
+			bcopy((char *)cp + 3,
+					(char *)&to->to_mopts.addr_id,
+					sizeof(to->to_mopts.addr_id));
+
+			/* is this a backup path */
+			if (subtype & IS_BACKUP) {
+				to->to_mopts.mpo_flags |= MPOF_BACKUP_PATH;
+			}
+
+			/* save the local_token */
+			bcopy((char *)cp + MP_RCV_TOKEN_OFFSET,
+					(char *)&to->to_mopts.rcv_token,
+					sizeof(to->to_mopts.rcv_token));
+			to->to_mopts.rcv_token =
+					ntohl(to->to_mopts.rcv_token);
+
+			/* save the senders random number */
+			bcopy((char *)cp + MP_SND_RND_OFFSET,
+					(char *)&to->to_mopts.snd_rnd,
+					sizeof(to->to_mopts.snd_rnd));
+			to->to_mopts.snd_rnd =
+								ntohl(to->to_mopts.snd_rnd);
+			to->to_mopts.mpo_flags |= MPOF_JOIN_SYN;
+			break;
+		case MPTCP_SUBLEN_MP_JOIN_SYNACK:
+			to->to_flags |= TOF_MPTCP;
+
+			/* copy option 'header' into struct */
+			bcopy((char *)cp,(char *)&mjoin,
+				sizeof(struct mp_join));
+			/* is this a backup path */
+			if (mjoin.sub_flags & IS_BACKUP) {
+				to->to_mopts.mpo_flags |= MPOF_BACKUP_PATH;
+			}
+//			/* save remote truncate MAC */
+			bcopy((char *)cp + MP_SND_MAC_OFFSET,
+			    (char *)&to->to_mopts.snd_trc_mac,
+			    sizeof(to->to_mopts.snd_trc_mac));
+			to->to_mopts.snd_trc_mac =
+			    be64toh(to->to_mopts.snd_trc_mac);
+
+			/* save the senders random number */
+			bcopy((char *)cp + MP_SND_RND_SYNACK_OFFSET,
+			    (char *)&to->to_mopts.snd_rnd,
+			    sizeof(to->to_mopts.snd_rnd));
+			to->to_mopts.snd_rnd =
+			    ntohl(to->to_mopts.snd_rnd);
+
+			to->to_mopts.mpo_flags |= MPOF_JOIN_SYNACK;
+			break;
+		case MPTCP_SUBLEN_MP_JOIN_ACK:
+			to->to_flags |= TOF_MPTCP;
+			/* sha is byte stream so byte order should be okay... */
+			bcopy((char *)cp + MP_SND_MAC_OFFSET,
+					(char *)to->to_mopts.snd_mac,
+					sizeof(to->to_mopts.snd_mac));
+
+			to->to_mopts.mpo_flags |= MPOF_JOIN_ACK;
+			to->to_mopts.mpo_flags |= MPOF_NEED_ACK;
+			break;
+		}
+		break;
+	}
+	case MPTCP_SUBTYPE_ADD_ADDR:
+	{
+		/* not using the port number field for now */
+		if (optlen != MPTCP_SUBLEN_ADD_ADDRV4 &&
+		    optlen != MPTCP_SUBLEN_ADD_ADDRV6)
+				break;
+
+		void * addr = NULL;
+		int addr_len = 0;
+
+		switch (optlen)
+		{
+		case MPTCP_SUBLEN_ADD_ADDRV4:
+			to->to_mopts.mpo_flags |= MPOF_ADD_ADDR_V4;
+			addr = &((struct sockaddr_in *)
+					&to->to_mopts.new_addr)->sin_addr.s_addr;
+			addr_len = 4;
+			/* Copy address ID */
+			break;
+		case MPTCP_SUBLEN_ADD_ADDRV6:
+			to->to_mopts.mpo_flags |= MPOF_ADD_ADDR_V6;
+			/* Copy INET address */
+			addr = &((struct sockaddr_in6 *)
+					&to->to_mopts.new_addr)->sin6_addr.__u6_addr;
+			addr_len = 16;
+			break;
+		}
+		/* Copy INET address */
+		bcopy((char *)cp + MP_ADD_ADDR_OFFSET, addr,
+		    addr_len);
+
+		/* Copy address ID */
+		bcopy((char *)cp + MP_ADDID_OFFSET,
+		    (char *)&to->to_mopts.addr_id,
+		    sizeof(to->to_mopts.addr_id));
+		break;
+	}
+	case MPTCP_SUBTYPE_REMOVE_ADDR:
+	{
+		break;
+	}
+	case MPTCP_SUBTYPE_MP_PRIO:
+	{
+		break;
+	}
+	case MPTCP_SUBTYPE_MP_FAIL:
+	{
+
+		break;
+	}
+	case MPTCP_SUBTYPE_MP_FASTCLOSE:
+	{
+		if (optlen != MPTCP_SUBTYPELEN_MP_FASTCLOSE)
+			break;
+
+		to->to_mopts.mpo_flags |= MPOF_FASTCLOSE;
+
+		bcopy((char *)cp + MP_FAIL_KEY_OFFSET,
+			(char *)&to->to_mopts.local_key,
+			sizeof(&to->to_mopts.local_key));
+		break;
+	}
+	} /* end of switch */
+}
+
 /*
  * Wrapper for the TCP established input helper hook.
  */
@@ -347,10 +660,11 @@
 	 * RFC3390 says only do this if SYN or SYN/ACK didn't got lost.
 	 * XXX: We currently check only in syncache_socket for that.
 	 */
-	if (V_tcp_do_rfc3390)
+	if (V_tcp_do_rfc3390) {
 		tp->snd_cwnd = min(4 * tp->t_maxseg,
 		    max(2 * tp->t_maxseg, 4380));
-	else
+		//max(2 * tp->t_maxseg, ((4380/tp->t_maxseg) * tp->t_maxseg)));
+	} else
 		tp->snd_cwnd = tp->t_maxseg;
 
 	if (CC_ALGO(tp)->conn_init != NULL)
@@ -838,10 +1152,12 @@
 		m_tag_delete(m, fwd_tag);
 	} else
 #endif /* IPFIREWALL_FORWARD */
+
 		inp = in_pcblookup_mbuf(&V_tcbinfo, ip->ip_src,
 		    th->th_sport, ip->ip_dst, th->th_dport,
 		    INPLOOKUP_WILDCARD | INPLOOKUP_WLOCKPCB,
 		    m->m_pkthdr.rcvif, m);
+
 #endif /* INET */
 
 	/*
@@ -1027,6 +1343,7 @@
 	 */
 	if (so->so_options & SO_ACCEPTCONN) {
 		struct in_conninfo inc;
+		int is_subflow = 0;
 
 		KASSERT(tp->t_state == TCPS_LISTEN, ("%s: so accepting but "
 		    "tp not listening", __func__));
@@ -1054,17 +1371,52 @@
 		 * socket appended to the listen queue in SYN_RECEIVED state.
 		 */
 		if ((thflags & (TH_RST|TH_ACK|TH_SYN)) == TH_ACK) {
+			int expand_result = 0;
 			/*
 			 * Parse the TCP options here because
 			 * syncookies need access to the reflected
 			 * timestamp.
 			 */
 			tcp_dooptions(&to, optp, optlen, 0);
+
+
+			/*
+			 * check for an mp_join option on the ACK. this means
+			 * that the handshake is for a mptcp subflow - thus
+			 * the path from here on should be different.
+			 *
+			 * might need to alter syncache_expand (dont't actually
+			 * want to allocate a new socket for a subflow, as it
+			 * should be associated with the socket of the master_tp
+			 *
+			 */
+
+//			printf("%s: ACK -> found inp at %p\n", __func__, inp);
+
 			/*
 			 * NB: syncache_expand() doesn't unlock
 			 * inp and tcpinfo locks.
 			 */
-			if (!syncache_expand(&inc, &to, th, &so, m)) {
+//			if (!syncache_expand(&inc, &to, th, &so, m)) {
+//				/*
+//				 * No syncache entry or ACK was not
+//				 * for our SYN/ACK.  Send a RST.
+//				 * NB: syncache did its own logging
+//				 * of the failure cause.
+//				 */
+//				rstreason = BANDLIM_RST_OPENPORT;
+//				goto dropwithreset;
+//			}
+
+			if (to.to_mopts.mpo_flags & MPOF_JOIN_ACK) {
+				expand_result =
+				    syncache_expand_subflow(&inc, &to, th, &so, m);
+				is_subflow = 1;
+			} else {
+				expand_result = syncache_expand(&inc, &to, th, &so, m);
+			}
+
+			if(!expand_result) {
 				/*
 				 * No syncache entry or ACK was not
 				 * for our SYN/ACK.  Send a RST.
@@ -1074,6 +1426,7 @@
 				rstreason = BANDLIM_RST_OPENPORT;
 				goto dropwithreset;
 			}
+
 			if (so == NULL) {
 				/*
 				 * We completed the 3-way handshake
@@ -1098,17 +1451,21 @@
 				} else
 					goto dropunlock;
 			}
-			/*
-			 * Socket is created in state SYN_RECEIVED.
-			 * Unlock the listen socket, lock the newly
-			 * created socket and update the tp variable.
-			 */
-			INP_WUNLOCK(inp);	/* listen socket */
-			inp = sotoinpcb(so);
-			INP_WLOCK(inp);		/* new connection */
-			tp = intotcpcb(inp);
+
+
+			INP_WUNLOCK(inp); /* listen socket */
+
+			/* need to get the inp for the sublfow */
+			if (is_subflow) {
+				tp = SLIST_FIRST(&intotcpcb(sotoinpcb(so))->t_mpcb->tp_list);
+			} else {
+				tp = intotcpcb(sotoinpcb(so));
+			}
+
+			INP_WLOCK(tp->t_inpcb); /* new connection */
 			KASSERT(tp->t_state == TCPS_SYN_RECEIVED,
 			    ("%s: ", __func__));
+
 #ifdef TCP_SIGNATURE
 			if (sig_checked == 0)  {
 				tcp_dooptions(&to, optp, optlen,
@@ -1330,7 +1687,9 @@
 			tcp_trace(TA_INPUT, ostate, tp,
 			    (void *)tcp_saveipgen, &tcp_savetcp, 0);
 #endif
-		tcp_dooptions(&to, optp, optlen, TO_SYN);
+
+		tcp_dooptions(&to, optp, optlen, TO_SYN);																	// HERE
+
 		syncache_add(&inc, &to, th, inp, &so, m, NULL, NULL);
 		/*
 		 * Entry added to syncache and mbuf consumed.
@@ -1419,10 +1778,13 @@
     int ti_locked)
 {
 	int thflags, acked, ourfinisacked, needoutput = 0;
-	int rstreason, todrop, win;
+	int rstreason = 0, todrop, win;
 	u_long tiwin;
 	struct tcpopt to;
 
+	struct mpcb *mp = tp->t_mpcb;
+	struct ds_map* map = NULL;
+
 #ifdef TCPDEBUG
 	/*
 	 * The size of tcp_saveipgen must be the size of the max ip header,
@@ -1529,12 +1891,293 @@
 			to.to_tsecr = 0;
 	}
 
+//	if (tp->t_mpcb->mp_state & MPS_PRE_ESTABLISHED)
+//		mp_init_established(tp);
+
+	/*
+	 * Need to send a data-level ACK in response to this segment
+	 */
+	if (to.to_mopts.mpo_flags & MPOF_NEED_ACK) {
+
+		//XXXNJW done with upcall to mp layer OR pass this info into tcp_output
+		// (via tcptops) and tcp_output can generate the D-ACK
+		tp->t_mpcb->mp_flags |= MPO_DATA_ACK;
+		tp->t_flags |= TF_ACKNOW;
+	}
+
+	/*
+	 * Got MP_JOIN option. If the length is correct tcp_output
+	 * will check this flag for MPOF_MP_JOIN and send a SYNACK
+	 * with MP_JOIN option. Otherwise just discard the segment.
+	 */
+	if (to.to_mopts.mpo_flags & MPOF_JOIN_SYN) {
+		mp_debug(MPSESSION, 4, 0, "%s: got JOIN_SYN\n", __func__);
+		/*
+		 * Got a MP_JOIN_SYN option. Need to send a JOIN_SYNACK
+		 * in reponse.
+		 */
+		if (to.to_mopts.optlen != MPTCP_SUBLEN_MP_JOIN_SYN) {
+			to.to_mopts.mpo_flags &= ~MPOF_MP_JOIN;
+			goto dropwithreset;
+		}
+		tp->sf_flags |= SFF_GOT_JOIN_SYN;
+	}
+	else if (to.to_mopts.mpo_flags & MPOF_JOIN_ACK) {
+		if (to.to_mopts.optlen == MPTCP_SUBLEN_MP_JOIN_ACK) {
+			/*
+			 * Got an ACK with MP_JOINACK in it. Go straight to established
+			 * since multipath is already active. We will also be sending an
+			 * ACK for this packet, which will put the active opener into
+			 * established for this subflow.
+			 */
+			tp->t_flags |= TF_ACKNOW;
+			tp->sf_flags |= SFF_GOT_JOIN_ACK;
+			mp_init_established(tp);
+		}
+	}
+
+	/*
+	 * Got a new DSS mapping for this subflow.
+	 */
+	if ((to.to_mopts.mpo_flags & MPOF_DSS)) {
+		//if(mp->mp_state == MPS_PRE_ESTABLISHED )
+			//mp->mp_state = MPS_ESTABLISHED;
+
+		/*
+		 * Convert 32bit DS map start sequence numbers into 64 bit.
+		 */
+		if ((to.to_mopts.mpo_flags & MPOF_DSN64) == 0 &&
+		    (to.to_mopts.mpo_flags & MPOF_DSN_MAP)) {
+
+			/* XXX: need to think about what value to key the if block off */
+			if(mp->direct_map) {
+				to.to_mopts.data_seq_num = (tp->t_mpcb->ds_idsr & 0xFFFFFFFF00000000)
+					| (uint32_t) to.to_mopts.data_seq_num;
+			} else {
+				to.to_mopts.data_seq_num =
+					(((tp->t_mpcb->ds_rcv_nxt) & 0xFFFFFFFF00000000)
+					| (uint32_t) to.to_mopts.data_seq_num);
+				if ((uint32_t)tp->t_mpcb->ds_rcv_nxt > (uint32_t)to.to_mopts.data_seq_num) {
+					mp_debug(MPSESSION, 4, 0, "%s: detected wrap on lower 32 of ds_rcv_nxt %ju: %u, dsn map start %ju : %u\n",
+					    __func__, tp->t_mpcb->ds_rcv_nxt, (uint32_t)tp->t_mpcb->ds_rcv_nxt,
+					    to.to_mopts.data_seq_num, (uint32_t)to.to_mopts.data_seq_num);
+					to.to_mopts.data_seq_num += ((uint64_t)1 << 32);
+				}
+			}
+
+		}
+
+		if ((to.to_mopts.mpo_flags & MPOF_ACK64) == 0 &&
+		    (to.to_mopts.mpo_flags & MPOF_DATA_ACK)) {
+			if(mp->direct_map)
+				to.to_mopts.data_ack_num = (tp->t_mpcb->ds_idsn & 0xFFFFFFFF00000000)
+					| (uint32_t) to.to_mopts.data_ack_num;
+			else {
+				to.to_mopts.data_ack_num =
+					(((tp->t_mpcb->ds_snd_una) & 0xFFFFFFFF00000000)
+					| (uint32_t) to.to_mopts.data_ack_num);
+				if ((uint32_t)tp->t_mpcb->ds_snd_una > (uint32_t)to.to_mopts.data_ack_num) {
+					mp_debug(MPSESSION, 4, 0, "%s: detected wrap on lower 32 of ds_snd_una %ju : %u, data ack %ju : %u\n",
+					    __func__, tp->t_mpcb->ds_snd_una, (uint32_t)tp->t_mpcb->ds_snd_una,
+					    to.to_mopts.data_ack_num, (uint32_t)to.to_mopts.data_ack_num);
+					to.to_mopts.data_ack_num += ((uint64_t)1 << 32);
+				}
+			}
+		}
+
+		/*
+		 * Got a data-level ACK
+		 */
+		if ((to.to_mopts.mpo_flags & MPOF_DATA_ACK)) {
+			to.to_mopts.mpo_flags &= ~MPOF_DATA_ACK;
+			mp_data_ack(mp, to.to_mopts.data_ack_num);
+		}
+
+		/*
+		 * XXX: inifnite map = 1 for new flows, so when we get the
+		 * first DSN on an active opener we can use it to set our
+		 * initial rcv_nxt. BUT what if we want to specify our own
+		 * ds_rcv number space (by advertising a D-ACK....)
+		 */
+		if (to.to_mopts.mpo_flags & MPOF_DATA_FIN)
+			printf("%s: processed DFIN option\n",__func__);
+			//tp->t_state = TCPS_CLOSE_WAIT;						//XXXNJW to uncomment
+
+
+		if (to.to_mopts.mpo_flags & MPOF_DSN_MAP) {
+
+
+			/* got a DSN with no length, drop to infinite mapping */
+			if (to.to_mopts.dss_data_len == 0)
+				panic("dropping back to infinite map not implemented\n");
+
+			/* find the map that this segment belongs to */
+			TAILQ_FOREACH(map, &tp->t_rxdsmaps, sf_ds_map_next) {
+				if (to.to_mopts.data_seq_num
+				    > map->ds_map_start + map->ds_map_len) {
+					map = NULL;
+					break;
+				}
+
+				if (to.to_mopts.data_seq_num >= map->ds_map_start)
+					break;
+			}
+
+			/*
+			 * Could not find a map covered by this sequence number,
+			 * so we allocate a new map and put into mapping list.
+			 *
+			 * Also for cases where !has_dsn_map (map will be NULL
+			 * in this case)
+			 *
+			 * XXX: should use zone allocator
+			 */
+
+			/*
+			 * XXXNJW: Need to think about coalescing mappings that overlap on
+			 * the right hand edge.
+			 * X
+			 */
+			if (map == NULL) {
+				int found_dup_map = 0;
+
+				/* inserting receive maps in subflow sequence order */
+				struct ds_map *next_map;
+				TAILQ_FOREACH(next_map, &tp->t_rxdsmaps, sf_ds_map_next) {
+					if (to.to_mopts.sub_seq_num + tp->irs > next_map->sf_seq_start) {
+						break;
+					} else if (to.to_mopts.sub_seq_num + tp->irs ==
+					      next_map->sf_seq_start) {
+						KASSERT(to.to_mopts.data_seq_num == next_map->ds_map_start
+								&& to.to_mopts.dss_data_len == next_map->ds_map_len
+								&& to.to_mopts.dss_csum == next_map->ds_map_csum
+								,("SF sequence number matches existing map "
+								 "but maps are not the same\n"));
+						found_dup_map = 1;
+						break;
+					}
+				}
+
+				if (!found_dup_map) {
+
+					map = malloc(sizeof(struct ds_map), M_DSSMAP, M_NOWAIT);
+
+					/* set values for mapping */
+					map->ds_map_start = to.to_mopts.data_seq_num;
+					map->sf_seq_start = to.to_mopts.sub_seq_num + tp->irs;
+					map->ds_map_len = to.to_mopts.dss_data_len;
+					map->ds_map_csum = to.to_mopts.dss_csum;
+
+					/* if there are no existing maps */
+					if (next_map == NULL) {
+						KASSERT(TAILQ_EMPTY(&tp->t_rxdsmaps),
+							("Incoming sequence less than those in rx map\n"));
+						TAILQ_INSERT_HEAD(&tp->t_rxdsmaps, map, sf_ds_map_next);
+					} else {
+						TAILQ_INSERT_BEFORE(next_map, map, sf_ds_map_next);
+					}
+
+//					printf("inserted map: ds_map_start %ju : %u, sf_seq_start: %u. len: %d\n",
+//						(uintmax_t) map->ds_map_start, (uint32_t) map->ds_map_start,
+//						map->sf_seq_start, map->ds_map_len);
+				} else {
+					printf("skipped duplicate map: ds_map_start %ju : %u, sf_seq_start: %u. len: %d\n",
+					    (uintmax_t) next_map->ds_map_start, (uint32_t) next_map->ds_map_start,
+					    next_map->sf_seq_start, next_map->ds_map_len);
+				}
+
+				/*
+				 * If in direct mapping mode and have received a DSS, then
+				 * change ds_rcv_nxt to the incoming DSN. We are no longer
+				 * in direct map mode at this point.
+				 * XXXNJW: Shared data access
+				 */
+				if (tp->t_mpcb->direct_map) {
+					tp->t_mpcb->ds_rcv_nxt = to.to_mopts.data_seq_num;
+					tp->t_mpcb->direct_map = 0;
+				}
+			}
+		}
+	}
+
+	/*
+	 * Processing ADD_ADDR options. This will add the new remote address
+	 * to the path manager, making it available for this mp connection.
+	 * Usually a server might advertise additional address that a client
+	 * can connect to.
+	 */
+	if (to.to_mopts.mpo_flags & (MPOF_ADD_ADDR_V4 | MPOF_ADD_ADDR_V6)) {
+		/* insert into list of usable addresses at index AddrID */
+		/* store the in_addr in the sockaddr_storage */
+		bcopy(&mp_usable_addresses[to.to_mopts.addr_id],
+		    &to.to_mopts.new_addr, sizeof(struct sockaddr_storage));
+	}
+
+
+	if (tlen) {
+		/*
+		 * Tag the mbuf with data-level sequence number. A direct
+		 * map will map the tcp sequence number directly to the
+		 * data sequence number. Otherwise calculate the dsn and
+		 * tag the mbuf with this value.
+		 */
+		struct dsn_tag *dtag = (struct dsn_tag *)
+					m_tag_alloc(PACKET_COOKIE_MPTCP,
+					PACKET_TAG_DSN, DSN_LEN, M_NOWAIT); // space for 64-bit DSN
+		struct m_tag *mtag = &dtag->tag;
+
+		//XXXNJW: shared data access
+		if (tp->t_mpcb->direct_map) {
+			dtag->dsn = th->th_seq;
+		} else {
+			if (map == NULL) {
+				/* find the map that this segment belongs to */
+				TAILQ_FOREACH(map, &tp->t_rxdsmaps, sf_ds_map_next) {
+					/*
+					 * XXXNJW: The following panic needs to be changed to handle
+					 * the buffering of packets beyond the mapped area (for cases where
+					 * the DSN-carrying packet has been lost, or arrives out of order.
+					 */
+					if (th->th_seq > map->sf_seq_start + map->ds_map_len)
+						panic("%s: Received data beyond end of mapped region\n", __func__);
+
+					/* A map exists for this packet */
+					if (th->th_seq >= map->sf_seq_start)
+						break;
+				}
+
+//				printf("found map: ds_map_start %ju, sd_seq_start: %u. len: %d\n",
+//				    map->ds_map_start, map->sf_seq_start, map->ds_map_len);
+			}
+
+			KASSERT(map != NULL, ("%s:%d No map found for packet with "
+			    "length %d, mp_active is: %d\n",
+			    __func__, __LINE__, tlen, tp->mp_active));
+			/* update map details */
+			dtag->dsn = map->ds_map_start + th->th_seq - map->sf_seq_start;
+
+			if (th->th_seq + tlen == map->sf_seq_start + map->ds_map_len) {
+				TAILQ_REMOVE(&tp->t_rxdsmaps, map, sf_ds_map_next);
+				free(map, M_DSSMAP);
+			}
+		}
+
+		/* And prepend the mtag, to be checked in reass */
+		m_tag_prepend(m, mtag);
+	}
+
 	/*
 	 * Process options only when we get SYN/ACK back. The SYN case
 	 * for incoming connections is handled in tcp_syncache.
 	 * According to RFC1323 the window field in a SYN (i.e., a <SYN>
 	 * or <SYN,ACK>) segment itself is never scaled.
-	 * XXX this is traditional behavior, may need to be cleaned up.
+	 * XXX this is traditional behaviour, may need to be cleaned up.
+	 */
+
+	/*
+	 * There is some access to a shared structure in here, but at this
+	 * point there will only ever be a single subflow, so this might
+	 * not cause any problems?
 	 */
 	if (tp->t_state == TCPS_SYN_SENT && (thflags & TH_SYN)) {
 		if ((to.to_flags & TOF_SCALE) &&
@@ -1557,8 +2200,60 @@
 		if ((tp->t_flags & TF_SACK_PERMIT) &&
 		    (to.to_flags & TOF_SACKPERM) == 0)
 			tp->t_flags &= ~TF_SACK_PERMIT;
+
+		if (to.to_flags & TOF_MPTCP) {
+			if (IS_MASTER_TP(tp)) {
+				if (tp->sent_capable) {
+					mp_process_remote_key(tp->t_mpcb, to.to_mopts.remote_key);
+					/* send mp_cabable ACK */
+					tp->sf_flags |= SFF_GOT_SYNACK;
+
+					/* we know the other end is mp enabled */
+					tp->mpc = 1;
+					/* enable csum if remote end sets csum bit */
+					if (to.to_mopts.mpo_flags & MPOF_USE_CSUM)
+						tp->t_mpcb->csum_enabled = 1;
+
+				} else {
+					/* got an MP_CAPABLE but did not send this option */
+					tp->mpc = 1;
+					tp->mp_active = 0;
+				}
+			} else {
+				// could be a subflow SYN
+				if (to.to_mopts.mpo_flags & MPOF_JOIN_SYNACK) {
+
+					if (to.to_mopts.mpo_flags & MPOF_BACKUP_PATH) {
+						// this flow is a backup path
+					}
+
+					/* mp is available on this flow */
+					tp->mpc = 1;
+
+					// sender's truncated MAC = to.to_mopts.snd_trc_mac
+					tp->remote_rand = to.to_mopts.snd_rnd;
+
+					// need to calculate a MAC to return in the MP_JOIN ACK
+					// using the random number just rcvd, and the keys from
+					// the initial mp establishment
+
+					/* Calculate MAC-A */
+					uint8_t digest[20];
+					uint32_t mac_len = mp_get_hmac(digest, mp, tp);
+
+					if (mac_len == 0) {
+						printf("%s: error computing MAC-A\n", __func__);
+						goto dropwithreset;
+					}
+
+					tp->sf_flags |= SFF_GOT_JOIN_SYNACK;
+				}
+			}
+		}
+
 	}
 
+
 	/*
 	 * Header prediction: check for the two common cases
 	 * of a uni-directional data xfer.  If the packet has
@@ -1582,7 +2277,7 @@
 	    tp->snd_nxt == tp->snd_max &&
 	    tiwin && tiwin == tp->snd_wnd && 
 	    ((tp->t_flags & (TF_NEEDSYN|TF_NEEDFIN)) == 0) &&
-	    LIST_EMPTY(&tp->t_segq) &&
+	    !tp->t_segq->disordered &&											// XXXNJW: check disordered
 	    ((to.to_flags & TOF_TS) == 0 ||
 	     TSTMP_GEQ(to.to_tsval, tp->ts_recent)) ) {
 
@@ -1653,8 +2348,7 @@
 				hhook_run_tcp_est_in(tp, th, &to);
 
 				TCPSTAT_INC(tcps_rcvackpack);
-				TCPSTAT_ADD(tcps_rcvackbyte, acked);
-				sbdrop(&so->so_snd, acked);
+				TCPSTAT_ADD(tcps_rcvackbyte, acked); // pure ack for outstanding
 				if (SEQ_GT(tp->snd_una, tp->snd_recover) &&
 				    SEQ_LEQ(th->th_ack, tp->snd_recover))
 					tp->snd_recover = th->th_ack - 1;
@@ -1666,8 +2360,17 @@
 				 * window.
 				 */
 				cc_ack_received(tp, th, CC_ACK);
-
 				tp->snd_una = th->th_ack;
+
+				/* Can't have an ACK of a FIN here, so do not need to adjust
+				 * by one byte here.
+				 * XXX: This is also a temporary hack and should be changed
+				 */
+				if (tp->t_mpcb->direct_map) {
+					atomic_subtract_int(&so->so_snd.sb_cc, acked);
+				}
+				tcp_ackmap(tp, th);
+
 				/*
 				 * Pull snd_wl2 up to prevent seq wrap relative
 				 * to th_ack.
@@ -1697,8 +2400,11 @@
 				else if (!tcp_timer_active(tp, TT_PERSIST))
 					tcp_timer_activate(tp, TT_REXMT,
 						      tp->t_rxtcur);
-				sowwakeup(so);
-				if (so->so_snd.sb_cc)
+
+				/* XXXNJW: macro for the first condition below (i.e. unmapped data in sb) */
+				if (SB_NUNMAPPED(&so->so_snd, mp) > 0
+				    || (TAILQ_FIRST(&tp->t_txdsmaps) != NULL &&
+				    !(TAILQ_FIRST(&tp->t_txdsmaps)->flags & MAPF_IS_SENT)))
 					(void) tcp_output(tp);
 				goto check_delack;
 			}
@@ -1719,7 +2425,6 @@
 			if ((tp->t_flags & TF_SACK_PERMIT) && tp->rcv_numsacks)
 				tcp_clean_sackreport(tp);
 			TCPSTAT_INC(tcps_preddat);
-			tp->rcv_nxt += tlen;
 			/*
 			 * Pull snd_wl1 up to prevent seq wrap relative to
 			 * th_seq.
@@ -1732,7 +2437,7 @@
 			tp->rcv_up = tp->rcv_nxt;
 			TCPSTAT_INC(tcps_rcvpack);
 			TCPSTAT_ADD(tcps_rcvbyte, tlen);
-			ND6_HINT(tp);	/* Some progress has been made */
+			//ND6_HINT(tp);	/* Some progress has been made */
 #ifdef TCPDEBUG
 			if (so->so_options & SO_DEBUG)
 				tcp_trace(TA_INPUT, ostate, tp,
@@ -1771,6 +2476,11 @@
 		 * TODO: Only step up if the application is actually serving
 		 * the buffer to better manage the socket buffer resources.
 		 */
+
+			/*
+			 * XXXNJW: Auto buffer tuning will not work as we no longer store
+			 * things in the socket buffers
+			 */
 			if (V_tcp_do_autorcvbuf &&
 			    to.to_tsecr &&
 			    (so->so_rcv.sb_flags & SB_AUTOSIZE)) {
@@ -1806,10 +2516,17 @@
 					    newsize, so, NULL))
 						so->so_rcv.sb_flags &= ~SB_AUTOSIZE;
 				m_adj(m, drop_hdrlen);	/* delayed header drop */
-				sbappendstream_locked(&so->so_rcv, m);
+
+				/*
+				 * tcp_reass will aquire lock only if it needs to do
+				 * reassembly.
+				 */
+				SOCKBUF_UNLOCK(&so->so_rcv);
+				thflags = tcp_reass(tp, th, &tlen, m);
 			}
 			/* NB: sorwakeup_locked() does an implicit unlock. */
-			sorwakeup_locked(so);
+			//sorwakeup_locked(so); // this is called from tcp_reass now
+
 			if (DELAY_ACK(tp)) {
 				tp->t_flags |= TF_DELACK;
 			} else {
@@ -1879,6 +2596,8 @@
 			goto drop;
 
 		tp->irs = th->th_seq;
+		if (IS_MASTER_TP(tp))
+			tp->t_mpcb->ds_rcv_nxt = tp->irs + 1;
 		tcp_rcvseqinit(tp);
 		if (thflags & TH_ACK) {
 			TCPSTAT_INC(tcps_connects);
@@ -1894,6 +2613,7 @@
 			tp->rcv_adv += imin(tp->rcv_wnd,
 			    TCP_MAXWIN << tp->rcv_scale);
 			tp->snd_una++;		/* SYN is acked */
+
 			/*
 			 * If there's data, delay ACK; if there's also a FIN
 			 * ACKNOW will be turned on later.
@@ -1908,7 +2628,7 @@
 				tp->t_flags |= TF_ECN_PERMIT;
 				TCPSTAT_INC(tcps_ecn_shs);
 			}
-			
+
 			/*
 			 * Received <SYN,ACK> in SYN_SENT[*] state.
 			 * Transitions:
@@ -1925,6 +2645,17 @@
 				cc_conn_init(tp);
 				tcp_timer_activate(tp, TT_KEEP,
 				    TP_KEEPIDLE(tp));
+				if (to.to_flags & TOF_MPTCP) {
+					if (tp->sent_capable) {
+						/* active open */
+
+						// XXXNJW shared access. might be okay as only one subflow
+						// will exist at this point
+						/* Don't want a new subflow to switch the mp state */
+						if(IS_MASTER_TP(tp))
+							mp_init_established(tp);
+					}
+				}
 			}
 		} else {
 			/*
@@ -2329,6 +3060,12 @@
 			tp->t_state = TCPS_ESTABLISHED;
 			cc_conn_init(tp);
 			tcp_timer_activate(tp, TT_KEEP, TP_KEEPIDLE(tp));
+			if (to.to_flags & TOF_MPTCP) {
+				/* passive open */
+				if(tp->mpc && tp->sent_capable) {
+					mp_init_established(tp);
+				}
+			}
 		}
 		/*
 		 * If segment contains data or ACK, will call tcp_reass()
@@ -2349,6 +3086,12 @@
 	 * more up to date window information we update our window information.
 	 */
 	case TCPS_ESTABLISHED:
+		if(!IS_MASTER_TP(tp) && tp->sf_state == MPS_PRE_ESTABLISHED) {
+			tp->mp_active = 1;
+			tp->sf_state = MPS_ESTABLISHED;
+			mp_debug(MPSESSION, 4, 0, "%s: set subflow as mp_active\n", __func__);
+		}
+		/* drop through */
 	case TCPS_FIN_WAIT_1:
 	case TCPS_FIN_WAIT_2:
 	case TCPS_CLOSE_WAIT:
